;VERSION:007
;NEXT VERSION:

dir struc
    fnam db 8 dup (?)
    ext  db 3 dup (?)
    attr db ?
         db 10 dup (?)
    time dw ?
    date dw ?
    adr  dw ?
    len  dd ?
ends

filedesc struc
    actv db 0
    addr dw 0
    driv db 0
    leng dd 0
    seek dd 0
         db 20 dup (0)
ends

disk macro
init:    db 0 ;Status of initialization
bytesec: dw 0 ;Byte per sector
secclas: db 0 ;Sector per claster
numfat:  db 0 ;Number of FAT
recroot: dw 0 ;Number of record in ROOT directory
numsec:  dw 0 ;Number of sector
secfat:  dw 0 ;Number of sector in FAT
sectrk:  dw 0 ;Number of sector in Track
numhead: dw 0 ;Number of head
fat1ofs: dw 0 ;Offset of FAT 1
fat2ofs: dw 0 ;Offset of FAT 2
rootofs: dw 0 ;Offset of ROOT dirctory
dataofs: dw 0 ;Offset of logical sector 0
dirclas: dw 0 ;Number claster of current directory
fattype: db 0 ;Type of FAT
         db 5 dup (0) ;Reserved
endm

.model tiny
.code
.386

body:
        cli
        mov ax,cs
        mov ds,ax
        mov es,ax
        mov ss,ax
        xor sp,sp
        xor bp,bp
        sti

        lea si,msg1            ;Out message
        call prnstr

        mov al,21h             ;Set vector 21h
        lea dx,int21handler
        call setvect

        mov al,24h             ;Set vector 24h
        lea dx,int24handler
        call setvect

        mov al,25h             ;Set vector 25h
        lea dx,int25handler
        call setvect

        mov al,26h             ;Set vector 26h
        lea dx,int26handler
        call setvect

;        mov al,0h              ;Set vector 00h
;        lea dx,int00handler
;        call setvect

;        mov al,4h              ;Set vector 04h
;        lea dx,int04handler
;        call setvect

        mov cs:word ptr lastptr,100h
        mov ax,offset kernelend
        mov cl,4
        shr ax,cl
        add cs:word ptr lastptr,ax

        mov ax,0700h
        mov cs:word ptr dopaddr,ax
        mov ax,0500h
        mov cs:word ptr fileaddr,ax
        mov ax,0600h
        mov cs:word ptr buffaddr,ax
        mov al,20
        mov cs:byte ptr files,al
        mov al,10
        mov cs:byte ptr buffers,al

        mov ax,0
        int 13h

        call diskinit

;        mov al,0
;        mov cs:word ptr dirclas,0
;        lea dx,pth
;        call chdir

        mov al,0
        lea dx,gfu                   ;TEST
        call openfile
        mov bp,ax

;        mov bx,bp
;        mov al,02h
;        xor dx,dx
;        xor cx,cx
;        call moveseek

        mov bx,bp
        mov cx,6340
        push ds
        xor dx,dx
        mov ax,cs:word ptr lastptr
        mov cs:word ptr kkk,ax
        mov ds,ax
        call fileread
        pop ds

        mov bx,bp
        call closehan

;        mov dl,0
jamp:   db 0eah
        dw 0h
kkk:    dw 0h

        jmp halt

;----------------ࠡ稪 INT 21H------------------
;09h,0eh,19h,25h,2ah,2ch,30h,35h,3dh,3eh,3fh,42h
int21handler:
        cmp ah,09
        jne h09
        push si
        mov si,dx
        call prnstr
        pop si
        iret
h09:
        cmp ah,0eh
        jne h0e
        mov cs:byte ptr actdisk,dl;쪮  祭 !
        iret
h0e:
        cmp ah,19h
        jne h19
        mov al,cs:byte ptr [actdisk]
        iret
h19:
        cmp ah,25h
        jne h25
        call setvect
        iret
h25:
        cmp ah,2ah
        jne h2a
        mov ah,04h
        int 1ah
        xchg al,dl
        call bcdtobin
        xchg al,dl
        xchg al,dh
        call bcdtobin
        xchg al,dh
        xchg al,cl
        call bcdtobin
        xchg al,cl
        iret
h2a:
        cmp ah,2ch
        jne h2c
        mov ah,02h
        int 1ah
        xchg al,ch
        call bcdtobin
        xchg al,ch
        xchg al,cl
        call bcdtobin
        xchg al,cl
        xchg al,dh
        call bcdtobin
        xchg al,dh
        iret
h2c:
        cmp ah,30h
        jne h30
        mov ax,0007h
        mov bx,0h
        mov dx,0h
        iret
h30:
        cmp ah,35h
        jne h35
        call getvect
        iret
h35:
        cmp ah,3dh
        jne h3d
        call openfile   ;???????
        iret
h3d:
        cmp ah,3eh
        jne h3e
        call closehan
        iret
h3e:
        cmp ah,3fh
        jne h3f
        call fileread
        iret
h3f:
        cmp ah,42h
        jne h42
        call moveseek
        iret
h42:
        iret

notused:iret

;----------ࠡ稪 뢠 OS----------
int00handler:
        lea si,msg3
        call prnstr
        jmp halt

int04handler:
        lea si,msg4
        call prnstr
        jmp halt

int24handler:
        lea si,msg6
        call prnstr
        jmp halt

;------------------------------------------
h25sector:   db 0
h25head  :   db 0
h25disk  :   db 0
h25count :   dw 0
h25addr  :   dw 0
h25lsec  :   dd 0

int25handler:
        push es
        push ds
        pop es
        mov cs:byte ptr h25disk,al
        mov cs:word ptr h25addr,bx
        mov cs:word ptr h25count,cx
        mov cs:dword ptr h25lsec,edx
h4:
        mov ax,cs:word ptr h25lsec
        mov dx,cs:word ptr h25lsec+2
        mov bx,cs:word ptr sectrk
        div bx
        inc dx
        mov cs:byte ptr h25sector,dl;sector=DX

        mov bx,cs:word ptr numhead
        xor dx,dx
        div bx
        mov cs:byte ptr h25head,dl;head=DX

        mov ax,cs:word ptr sectrk
        mov bx,cs:word ptr numhead
        mul bx
        mov bx,ax
        ;DX:AX - DX  뢠
        mov ax,cs:word ptr h25lsec
        mov dx,cs:word ptr h25lsec+2
        div bx
                                  ;cylinder=ax
        mov cx,ax
        shl ch,6
        xchg cl,ch
        add cl,cs:byte ptr h25sector

        mov dl,cs:byte ptr h25disk
        mov dh,cs:byte ptr h25head
        mov bx,cs:word ptr h25addr
        mov ax,0201h
        int 13h
        jc h5

        dec cs:word ptr h25count
        cmp cs:word ptr h25count,0
        je h6
        inc cs:dword ptr h25lsec

        mov ax,cs:word ptr bytesec
        mov cl,4
        shr ax,cl

        mov dx,es
        add dx,ax
        mov es,dx

        jmp h4
h6:
        clc
        pop es
        iret

h5:     stc
        pop es
        iret
;------------------------
int26handler:
        push es
        push ds
        pop es
        mov cs:byte ptr h25disk,al
        mov cs:word ptr h25addr,bx
        mov cs:word ptr h25count,cx
        mov cs:dword ptr h25lsec,edx
h14:
        mov ax,cs:word ptr h25lsec
        mov dx,cs:word ptr h25lsec+2
        mov bx,cs:word ptr sectrk
        div bx
        inc dx
        mov cs:byte ptr h25sector,dl;sector=DX

        mov bx,cs:word ptr numhead
        xor dx,dx
        div bx
        mov cs:byte ptr h25head,dl;head=DX

        mov ax,cs:word ptr sectrk
        mov bx,cs:word ptr numhead
        mul bx
        mov bx,ax
        ;DX:AX - DX  뢠
        mov ax,cs:word ptr h25lsec
        mov dx,cs:word ptr h25lsec+2
        div bx
                                  ;cylinder=ax
        mov cx,ax
        shl ch,6
        xchg cl,ch
        add cl,cs:byte ptr h25sector

        mov dl,cs:byte ptr h25disk
        mov dh,cs:byte ptr h25head
        mov bx,cs:word ptr h25addr
        mov ax,0301h
        int 13h
        jc h15

        dec cs:word ptr h25count
        cmp cs:word ptr h25count,0
        je h16
        inc cs:dword ptr h25lsec

        mov ax,cs:word ptr bytesec
        mov cl,4
        shr ax,cl

        mov dx,es
        add dx,ax
        mov es,dx

        jmp h14
h16:
        clc
        pop es
        iret

h15:    stc
        pop es
        iret

;-------------Copyright----------------
        db 10,'Copyright (C) 1998 EXOS Technologies.'
        db 10,'Extended operation system verion 1.0 beta.'
        db 10,'All rights reseved.'
        db 10

;-------------ᯮ⥫ 㭪樨----------------
halt:
        lea si,msg2
        call prnstr
        sti
p3:     jmp p3

;----------------------
prnstr:
        push si ax bx           ;ப  DS:SI
        pushf
        cld
p1:
        lodsb                   ;AL=DS:[SI]
        cmp al,'$'
        je p2
        mov ah,0eh
        mov bx,0007h
        int 10h
        jmp p1
p2:     popf
        pop bx ax si
        ret

;----------------------
setvect:
        push es bx ax
        xor bx,bx
        mov es,bx
        xor ah,ah
        mov bl,4
        mul bl
        mov bx,ax
        mov es:[bx],dx
        mov es:[bx+2],ds
        pop ax bx es
        ret

;------------------------
getvect:
        push ds dx ax si
        xor dx,dx
        mov ds,dx
        xor ah,ah
        mov dl,4
        mul dl
        mov si,ax
        mov bx,[si]
        mov es,[si+2]
        pop si ax dx ds
        ret

;------------------------------
bcdtobin:             ;AL=BCD (2 digit)
        push cx
        push ax
        mov cl,4
        shr al,cl
        mov cl,10
        mul cl
        pop cx
        and cl,00001111b
        add ax,cx
        pop cx
        ret           ;AL=BIN

;------------------------------
clastosect:      ;claster=AX
       push ax bx cx
       movzx bx,cs:byte ptr secclas  ;?disk
       mul bx
       mov cl,8
       shl edx,cl
       mov dx,ax
       movzx eax,cs:word ptr dataofs
       dec eax
       dec eax
       add edx,eax
       pop cx bx ax
       ret       ;LSector=EDX

;-----------------------------
dg:  db '0123456789ABCDEF'
sa:  db '0000H',10,13,'$'

digitprn:     ; AX - ᫮
       push ax si di
       mov di,3
p4:
       push ax
       and ax,1111b
       mov si,ax
       mov ah,byte ptr dg[si]
       mov byte ptr sa[di],ah
       dec di
       pop ax
       shr ax,4
       jnz p4

       lea si,sa
       call prnstr
       pop di si ax
       ret
;-------------------------------
clasFAT:
       cmp cs:byte ptr FATtype,1      ;FAT12
       je clasFAT12
       cmp cs:byte ptr FATtype,2      ;FAT16
       je clasFAT16

;-------------------------------
clasFAT12:                       ;AX =    ᪠ ᫥饣
    push ds bx cx dx             ;DL = Drive
    push ax
    mov cl,dl
    mov bx,3    ;AX*3
    mul bx
    shr ax,1    ;AX/2

    ;if not exist_in_dop
    mov bx,512
    xor dx,dx
    div bx     ;AX/BX
    push dx

    movzx edx,ax
    add dx,cs:word ptr fat1ofs
    mov ax,cs:word ptr dopaddr
    mov ds,ax
    mov al,cl
    mov cx,2
    xor bx,bx
    int 25h

    pop bx
    mov ax,word ptr [bx]
    pop bx
    bt bx,0
    jc p14
    and ah,00001111b
    jmp p15
p14:
    mov cl,4
    shr ax,cl
p15:
    pop dx cx bx ds
    ret                 ;AX - ᫥饣

;----------------------
clasFAT16:              ;AX =    ᪠ ᫥饣
       push ds bx cx dx ;DL = Drive
       mov cl,dl
       shl ax,1    ;AX*2

       ;if not exist_in_dop
       mov bx,512
       xor dx,dx
       div bx     ;AX/BX
       push dx

       movzx edx,ax
       add dx,cs:word ptr fat1ofs
       mov ax,cs:word ptr dopaddr
       mov ds,ax
       xor bx,bx
       mov al,cl
       mov cx,1
       int 25h

       pop bx
       mov ax,word ptr [bx]
       pop dx cx bx ds
       ret                 ;AX - ᫥饣

;-------------------------------
fffo:  dw 0
fffd:  db 0

findfreeFAT:               ;DL-Drive
       mov cs:word ptr fffo,0
       mov cs:byte ptr fffd,dl

       cmp cs:byte ptr FATtype,1      ;FAT12
       je findfreeFAT12
       cmp cs:byte ptr FATtype,2      ;FAT16
       je findfreeFAT16

;-------------------------------
findfreeFAT16:             ;DL-Drive \\not tested
       push ds
       xor edx,edx
p66:
       push edx
       mov ax,cs:word ptr fat1ofs
       add dx,ax
       mov ax,cs:word ptr dopaddr
       mov ds,ax
       xor bx,bx
       mov al,cs:byte ptr fffd
       mov cx,1
       int 25h
       pop edx

       xor bx,bx
p69:
       inc cs:word ptr fffo
       cmp word ptr [bx],0
       je p70
       inc bx
       cmp bx,cs:word ptr bytesec
       jne p69

       inc dx
       cmp dx,cs:word ptr secfat
       jne p66
       stc
       pop ds
       ret

p70:   clc
       mov ax,cs:word ptr fffo
       pop ds
       ret                 ;AX - ᢮

;-------------------------------
findfreeFAT12:        ;DL-Drive
       push ds
       xor edx,edx
p67:
       push edx
       mov ax,cs:word ptr fat1ofs
       add dx,ax
       mov ax,cs:word ptr dopaddr
       mov ds,ax
       xor bx,bx
       mov al,cs:byte ptr fffd
       mov cx,2
       int 25h
       pop edx

       xor bx,bx
p73:
       push bx edx
       mov ax,3    ;BX*3
       mul bx
       shr ax,1    ;AX/2
       mov bx,ax

       mov ax,word ptr [bx]
       pop edx bx
       bt bx,0
       jc p68
       and ah,00001111b
       jmp p71
p68:
       mov cl,4
       shr ax,cl
p71:
       inc cs:word ptr fffo
       cmp ax,0
       je p72
       inc bx
       cmp bx,cs:word ptr bytesec
       jne p73
       inc dx
       cmp dx,cs:word ptr secfat
       jne p67

       stc
       pop ds
       ret

p72:   mov ax,cs:word ptr fffo
       dec ax
       clc
       pop ds
       ret                 ;AX - ᢮

;-------------------------------
hannumtoaddr:
       push ax cx
       mov si,bx          ;BX = Number of file descriptor
       mov cl,5
       shl si,cl
       mov ax,cs:word ptr fileaddr
       mov es,ax          ;ES:SI = Currentf file descriptor
       pop cx ax
       ret

;-------------------------------
makefilehan:
       push es ds
       xor bx,bx
       push es
       pop ds             ;ࠣ DIR
       sub di,11
p41:
       call hannumtoaddr

       cmp es:word ptr filedesc.actv[si],0
       je p40
       inc bx
       cmp bl,cs:byte ptr files
       jge p42
       jmp p41
p40:
       mov es:byte ptr filedesc.actv[si],1
       mov es:dword ptr filedesc.seek[si],0
       mov al,cs:byte ptr ddsk
       mov es:byte ptr filedesc.driv[si],al

       mov eax,dword ptr dir.len[di]
       mov es:dword ptr filedesc.leng[si],eax
       mov ax,word ptr dir.adr[di]
       mov es:word ptr filedesc.addr[si],ax

       clc
       pop ds es
       mov ax,bx ; AX-뤥 filehandler
       ret

p42:   stc
       pop ds es
       ret

;----------------------
fsec:  dw 0
fcls:  dw 0
fofs:  dw 0

fileread:                  ;⠥ ᪮쪮   BUFFERS !!!!29-06-98
    push ds es
    pushf
    push ds dx cx cx

    call hannumtoaddr

    mov ax,es:word ptr filedesc.seek[si]
    mov dx,es:word ptr filedesc.seek[si+2]

    mov al,ah
    mov ah,dl
    mov dl,dh
    xor dh,dh
    shr ax,1
    shr dx,1
    jnc p48
    add ax,8000h
p48:                   ;DX:AX = seek/512
    movzx bx,cs:byte ptr secclas
    div bx              ;Claster=AX,Sector_in_claster=DX
    mov cs:word ptr fsec,dx
    mov cs:word ptr fcls,ax


    mov dx,es:word ptr filedesc.seek[si+2]
    mov ax,es:word ptr filedesc.seek[si]
    mov bx,cs:word ptr bytesec
    div bx              ; ofset_in_Sector=DX
    mov cs:word ptr fofs,dx

    xor cx,cx
    mov ax,es:word ptr filedesc.addr[si]
    mov dl,es:byte ptr filedesc.driv[si]
p17:
    cmp cx,cs:word ptr fcls
    je p16
    call clasFAT
    inc cx
    jmp p17
p16:
    call clastosect            ;LSec=EDX

    mov ax,cs:word ptr fsec    ;????29-06-98
    cwde                       ;????29-06-98
    add edx,eax                ;????29-06-98

    xor bx,bx                  ;????28-06-98
    mov ax,cs:word ptr buffaddr
    mov ds,ax
    movzx cx,cs:byte ptr buffers
    mov al,es:byte ptr filedesc.driv[si]
    int 25h

    xor ecx,ecx
    pop cx
    mov edx,es:dword ptr filedesc.seek[si]
    add edx,ecx
    mov eax,es:dword ptr filedesc.leng[si]
    cmp edx,eax

    jge p19                         ;᫥ EOF
    sub eax,edx
    mov cx,ax
    jmp p18

p19:mov es:dword ptr filedesc.seek[si],eax
    sub edx,eax
    pop cx
    sub cx,dx
    push cx

p18:
    pop cx
    movzx eax,cx   ; 室 - ⠭ 
    add es:dword ptr filedesc.seek[si],eax
    mov si,cs:word ptr fofs
    pop di
    pop es
    cld
    rep movsb                   ;DS:SI -> ES:DI

    popf
    pop es ds
    ret

;-------------------------------
dofs:   dw 0
dcls:   dw 0
dstr:   dw 0
ddsk:   db 0

openfile:               ;DS:DX = ASCIIZ  ப  ᪠
    push es ds          ;AL-Drive
    mov cs:byte ptr ddsk,al
    mov cs:word ptr dstr,dx
    mov ax,cs:word ptr dirclas
    mov cs:word ptr dcls,ax      ;<<<
p29:
    mov cs:word ptr dofs,0
p27:
    push ds
    mov ax,cs:word ptr dcls      ;<<<
    cmp ax,0                     ;ROOT
    jne p60                      ;ROOT
    movzx edx,cs:word ptr rootofs;ROOT
    jmp p61                      ;ROOT
p60:call clastosect
p61:movzx eax,cs:word ptr dofs
    add edx,eax
    mov ax,cs:word ptr dopaddr
    mov ds,ax
    xor bx,bx
    mov al,cs:byte ptr ddsk
    mov cx,1
    int 25h                     ;Read the fragment of directory
    pop ds

    xor dx,dx                   ;Current record
    mov ax,cs:word ptr dopaddr
    mov es,ax

p22:
    mov ax,dx
    mov cl,5
    shl ax,cl

    mov cx,11
    mov si,cs:word ptr dstr     ;???????
    mov di,ax
    cmp es:byte ptr [di],0
    je p26        ;End of dir

p20:cmpsb
    jne p21
    dec cx

    jnz p20
    jmp p25

p21:inc dx
    cmp dx,16
    jne p22

    inc cs:word ptr dofs;next sector
    mov ax,cs:word ptr dofs
    cmp ax,cs:word ptr secclas
    je p28
    jmp p27

p28:mov ax,cs:word ptr dcls      ;<<<
    cmp ax,0                     ;ROOT
    je p26                       ;ROOT
    call clasFAT
    cmp ax,0FF0h
    jge p26
    mov cs:word ptr dcls,ax      ;<<<
    jmp p29

p25:call makefilehan      ;File OK
    pop ds es
    ret

p26:stc
    pop ds es
    ret

;-------------------------------
moveseek:                        ; AL = Type
       push es
       call hannumtoaddr         ; BX = Handler
       cmp al,0                  ; CX:DX = Seek
       jne p65
       mov es:word ptr filedesc.seek[si],dx
       mov es:word ptr filedesc.seek[si+2],cx
       xchg ax,dx
       mov dx,cx
       jmp p63

p65:   cmp al,1
       jne p64
       xchg ecx,ebx
       mov cl,8
       shl ebx,cl
       xchg ecx,ebx
       push dx
       xor edx,edx
       pop dx
       add ecx,edx      ;ECX = Seek
       add es:dword ptr filedesc.seek[si],ecx
       mov ax,es:word ptr filedesc.seek[si]
       mov dx,es:word ptr filedesc.seek[si+2]
       jmp p63

p64:   cmp al,2
       jne p62
       xchg ecx,ebx
       mov cl,8
       shl ebx,cl
       xchg ecx,ebx
       push dx
       xor edx,edx
       pop dx
       add ecx,edx      ;ECX = Seek
       mov edx,es:dword ptr filedesc.leng[si]
       add ecx,edx
       mov es:dword ptr filedesc.seek[si],ecx
       mov ax,es:word ptr filedesc.seek[si]
       mov dx,es:word ptr filedesc.seek[si+2]

p63:   clc                       ; DX:AX = Current seek
       pop es
       ret
p62:   stc
       pop es
       ret

;-------------------------------
closehan:
       push es si       ;BX -뢠 filehan
       cmp bl,cs:byte ptr files
       jg p43

       call hannumtoaddr

       mov es:word ptr filedesc.actv[si],0      ; ⨥
       clc
       pop si es
       ret

p43:   stc
       pop si es
       ret

;-------------------------------
finddir:               ;DS:DX = ASCIIZ  ப  ᪠
    push es ds         ;AL-Drive
    mov cs:byte ptr ddsk,al
    mov cs:word ptr dstr,dx
    mov ax,cs:word ptr dirclas
    mov cs:word ptr dcls,ax      ;<<<
p129:
    mov cs:word ptr dofs,0
p127:
    push ds
    mov ax,cs:word ptr dcls      ;<<<
    cmp ax,0                     ;ROOT
    jne p160                     ;ROOT
    movzx edx,cs:word ptr rootofs;ROOT
    jmp p161                     ;ROOT
p160: call clastosect
p161: movzx eax,cs:word ptr dofs
    add edx,eax
    mov ax,cs:word ptr dopaddr
    mov ds,ax
    xor bx,bx
    mov al,cs:byte ptr ddsk
    mov cx,1
    int 25h                     ;Read the fragment of directory
    pop ds

    xor dx,dx                   ;Current record
    mov ax,cs:word ptr dopaddr
    mov es,ax

p122:
    mov ax,dx
    mov cl,5
    shl ax,cl

    mov cx,11
    mov si,cs:word ptr dstr     ;???????
    mov di,ax
    cmp es:byte ptr [di],0
    je p126        ;End of dir

p120:cmpsb
    jne p121
    dec cx

    jnz p120

    test es:byte ptr [di],00010000b       ;ਡ
    jnz p125

p121:inc dx
    cmp dx,16
    jne p122

    inc cs:word ptr dofs;next sector
    mov ax,cs:word ptr dofs
    cmp ax,cs:word ptr secclas
    je p128
    jmp p127

p128:mov ax,cs:word ptr dcls     ;<<<
    cmp ax,0                     ;ROOT
    je p126                      ;ROOT

    call clasFAT
    cmp ax,0FF0h
    jge p126
    mov cs:word ptr dcls,ax
    jmp p129

p125:   ;Dir ok
    mov ax,es:word ptr [di+15]
    clc                         ;AX = Claster
    pop ds es
    ret

p126:
    stc
    pop ds es
    ret

;-------------------------------
chdir:  ;DS:DX = 
p51:    ;AL = Drive
       push dx ax
       call finddir
       jc p50
       mov cs:word ptr dirclas,ax
       pop ax dx
       add dx,11
       mov di,dx
       cmp byte ptr [di],0
       jne p51

       clc      ;Ok
       ret

p50:   pop dx ax
       stc      ;Path not found
       ret

;-------------------------------
diskinit:
       mov ax,0201h
       mov cx,0001h
;       mov dx,0180h        ;Disk C: !!!???
       mov dx,0000h        ;Disk A: !!!???
;       mov bx,cs:word ptr dopaddr  ;???????????
       mov bx,cs       ;TEST
       add bx,100h      ;TEST
       mov es,bx       ;TEST
       xor bx,bx
       int 13h
       jnc p5
       int 24h
p5:
       mov ax,word ptr es:[0bh]
       mov cs:word ptr bytesec,ax
       mov al,byte ptr es:[0dh]
       mov cs:byte ptr secclas,al
       mov al,byte ptr es:[10h]
       mov cs:byte ptr numfat,al
       mov ax,word ptr es:[11h]
       mov cs:word ptr recroot,ax
       mov ax,word ptr es:[13h]
       mov cs:word ptr numsec,ax
       mov ax,word ptr es:[16h]
       mov cs:word ptr secfat,ax
       mov ax,word ptr es:[18h]
       mov cs:word ptr sectrk,ax
       mov ax,word ptr es:[1ah]
       mov cs:word ptr numhead,ax

       mov ax,cs:word ptr secfat
       mov bl,cs:byte ptr numfat
       xor bh,bh
       mul bx
;      dx:ax  - DX  뢠
       push ax
       push ax
       mov ax,cs:word ptr recroot
       mov bx,20h
       mul bx
;      dx:ax  - DX  뢠
       mov bx,512
       div bx
       pop bx
       add ax,bx
       inc ax
       mov cs:word ptr dataofs,ax

       pop ax
       inc ax
       mov cs:word ptr rootofs,ax
       mov ax,1                         ;???????????
       mov cs:word ptr fat1ofs,ax       ;???????????
       add ax,cs:word ptr secfat        ;???????????
       mov cs:word ptr fat2ofs,ax       ;???????????

       mov cs:byte ptr FATtype,2        ;???????????
       mov al,byte ptr es:[15h]         ;??????????? IF HDD THEN FAT16 ELSE FAT12
       cmp al,0f8h                      ;???????????
       je p33                           ;???????????
       mov cs:byte ptr FATtype,1
p33:
       ret

;-----------------Variables--------------------------
disk

actdisk: db 0 ;Active disk
buffers: db 0 ;Number of buffer
files:   db 0 ;Number of files
disks:   db 0 ;Number of disks
dopaddr: dw 0 ;DOP addres
buffaddr:dw 0 ;Buffer addres
fileaddr:dw 0 ;Files addres
diskaddr:dw 0 ;Disk addres
lastptr: dw 0 ;砫 ᢮ ⪠ 

;-----------------Messages---------------------------

msg1:   db 'Starting Extended Operation System. Version 1.0 Beta.',10,13,'$'
msg2:   db 'System halted. Press ALT+CTRL+DEL to reboot.',10,13,'$'
msg3:   db 'Divide by zero.',10,13,'$'
msg4:   db 'Overflow error.',10,13,'$'
msg5:
msg6:   db 'Critical error.',10,13,'$'
msg7:
msg8:

sfn:     db 'EOSBOOT ASM',0
sfb:     db 'EXOS    BMP',0
bot:     db 'BOOT    OLD',0
pth:     db 'AAA        AAA1       ',0
gfu:     db 'GFU     SYS',0

kernelend:
    end body
